"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const material_1 = require("@mui/material");
const mui_1 = require("tss-react/mui");
const useStyles = (0, mui_1.makeStyles)()({
    ellipses: {
        textOverflow: 'ellipsis',
        overflow: 'hidden',
    },
});
function BlockMsg({ message, severity, buttonText, icon, action, }) {
    const { classes } = useStyles();
    const button = action ? (react_1.default.createElement(material_1.Button, { "data-testid": "reload_button", onClick: action, startIcon: icon }, buttonText)) : null;
    return (react_1.default.createElement(material_1.Alert, { severity: severity, action: button, classes: { message: classes.ellipses } },
        react_1.default.createElement(material_1.Tooltip, { title: message },
            react_1.default.createElement("div", null, message))));
}
exports.default = BlockMsg;
//# sourceMappingURL=BlockMsg.js.map