"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const BlockMsg_1 = __importDefault(require("../components/BlockMsg"));
function TooLargeMessage({ model, }) {
    const { regionTooLargeReason } = model;
    return (react_1.default.createElement(BlockMsg_1.default, { severity: "warning", action: () => {
            if (!model.estimatedRegionStats) {
                console.error('No global stats?');
            }
            else {
                model.updateStatsLimit(model.estimatedRegionStats);
                model.reload();
            }
        }, buttonText: "Force load", message: `${regionTooLargeReason ? regionTooLargeReason + '. ' : ''}
      Zoom in to see features or force load (may be slow).` }));
}
exports.default = TooLargeMessage;
//# sourceMappingURL=TooLargeMessage.js.map