"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.stateModelFactory = exports.configSchemaFactory = void 0;
const pluggableElementTypes_1 = require("@jbrowse/core/pluggableElementTypes");
// locals
const configSchema_1 = require("./configSchema");
Object.defineProperty(exports, "configSchemaFactory", { enumerable: true, get: function () { return configSchema_1.configSchemaFactory; } });
const model_1 = require("./model");
Object.defineProperty(exports, "stateModelFactory", { enumerable: true, get: function () { return model_1.stateModelFactory; } });
const BaseLinearDisplay_1 = require("../BaseLinearDisplay/");
exports.default = (pluginManager) => {
    pluginManager.addDisplayType(() => {
        const configSchema = (0, configSchema_1.configSchemaFactory)(pluginManager);
        return new pluggableElementTypes_1.DisplayType({
            name: 'LinearBareDisplay',
            configSchema,
            stateModel: (0, model_1.stateModelFactory)(configSchema),
            trackType: 'BasicTrack',
            viewType: 'LinearGenomeView',
            ReactComponent: BaseLinearDisplay_1.BaseLinearDisplayComponent,
        });
    });
};
//# sourceMappingURL=index.js.map