"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const configuration_1 = require("@jbrowse/core/configuration");
const BaseLinearDisplay_1 = require("../BaseLinearDisplay");
/**
 * #config LinearBasicDisplay
 */
function configSchemaFactory(pluginManager) {
    return (0, configuration_1.ConfigurationSchema)('LinearBasicDisplay', {
        /**
         * #slot
         */
        mouseover: {
            type: 'string',
            description: 'what to display in a given mouseover',
            defaultValue: `jexl:get(feature,'name')`,
            contextVariable: ['feature'],
        },
        /**
         * #slot
         */
        renderer: pluginManager.pluggableConfigSchemaType('renderer'),
    }, {
        /**
         * #baseConfiguration
         */
        baseConfiguration: BaseLinearDisplay_1.baseLinearDisplayConfigSchema,
        explicitlyTyped: true,
    });
}
exports.default = configSchemaFactory;
//# sourceMappingURL=configSchema.js.map