"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.configSchema = exports.modelFactory = void 0;
const pluggableElementTypes_1 = require("@jbrowse/core/pluggableElementTypes");
const BaseLinearDisplay_1 = require("../BaseLinearDisplay");
// locals
const configSchema_1 = __importDefault(require("./configSchema"));
exports.configSchema = configSchema_1.default;
const model_1 = __importDefault(require("./model"));
exports.modelFactory = model_1.default;
exports.default = (pluginManager) => {
    pluginManager.addDisplayType(() => {
        const config = (0, configSchema_1.default)(pluginManager);
        return new pluggableElementTypes_1.DisplayType({
            name: 'LinearBasicDisplay',
            displayName: 'Basic deature display',
            configSchema: config,
            stateModel: (0, model_1.default)(config),
            trackType: 'FeatureTrack',
            viewType: 'LinearGenomeView',
            ReactComponent: BaseLinearDisplay_1.BaseLinearDisplayComponent,
        });
    });
};
//# sourceMappingURL=index.js.map