"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const mui_1 = require("tss-react/mui");
const mobx_react_1 = require("mobx-react");
const util_1 = require("@jbrowse/core/util");
// locals
const util_2 = require("../util");
const useStyles = (0, mui_1.makeStyles)()({
    majorTickLabel: {
        fontSize: '11px',
    },
    majorTick: {
        stroke: '#555',
    },
    minorTick: {
        stroke: '#999',
    },
});
function Ruler({ start, end, bpPerPx, reversed = false, major = true, minor = true, }) {
    const { classes } = useStyles();
    const ticks = (0, util_2.makeTicks)(start, end, bpPerPx, major, minor);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        ticks.map(tick => {
            const x = (reversed ? end - tick.base : tick.base - start) / bpPerPx;
            return (react_1.default.createElement("line", { key: tick.base, x1: x, x2: x, y1: 0, y2: tick.type === 'major' ? 6 : 4, strokeWidth: 1, stroke: tick.type === 'major' ? '#555' : '#999', className: tick.type === 'major' ? classes.majorTick : classes.minorTick, "data-bp": tick.base }));
        }),
        ticks
            .filter(tick => tick.type === 'major')
            .map(tick => {
            const x = (reversed ? end - tick.base : tick.base - start) / bpPerPx;
            return (react_1.default.createElement("text", { x: x - 3, y: 7 + 11, key: `label-${tick.base}`, style: { fontSize: '11px' }, className: classes.majorTickLabel }, (0, util_1.getTickDisplayStr)(tick.base + 1, bpPerPx)));
        })));
}
exports.default = (0, mobx_react_1.observer)(Ruler);
//# sourceMappingURL=Ruler.js.map