import React from 'react';
import { Tooltip, Button, Alert } from '@mui/material';
import { makeStyles } from 'tss-react/mui';
const useStyles = makeStyles()({
    ellipses: {
        textOverflow: 'ellipsis',
        overflow: 'hidden',
    },
});
export default function BlockMsg({ message, severity, buttonText, icon, action, }) {
    const { classes } = useStyles();
    const button = action ? (React.createElement(Button, { "data-testid": "reload_button", onClick: action, startIcon: icon }, buttonText)) : null;
    return (React.createElement(Alert, { severity: severity, action: button, classes: { message: classes.ellipses } },
        React.createElement(Tooltip, { title: message },
            React.createElement("div", null, message))));
}
//# sourceMappingURL=BlockMsg.js.map