import React from 'react';
import BlockMsg from '../components/BlockMsg';
function TooLargeMessage({ model, }) {
    const { regionTooLargeReason } = model;
    return (React.createElement(BlockMsg, { severity: "warning", action: () => {
            if (!model.estimatedRegionStats) {
                console.error('No global stats?');
            }
            else {
                model.updateStatsLimit(model.estimatedRegionStats);
                model.reload();
            }
        }, buttonText: "Force load", message: `${regionTooLargeReason ? regionTooLargeReason + '. ' : ''}
      Zoom in to see features or force load (may be slow).` }));
}
export default TooLargeMessage;
//# sourceMappingURL=TooLargeMessage.js.map